export declare type FILTER_TYPE = 'TEXT' | 'ENUM';
export declare type SORT_ORDER = 'ASC' | 'DESC';
export declare type ISuperTableSorter = (row1Value: any, row2Value: any, row1: Object, row2: Object) => number;
export interface IBuiltInSorters {
    STRING: ISuperTableSorter;
    NUMBER: ISuperTableSorter;
}
export declare type ISuperTableCellFormatter = (value: any, row: Object, column: ColumnState) => string;
export interface ISuperTableOptions {
    autoHeight?: boolean;
}
export interface ColumnState {
    id: string;
    filterValue: any;
    sortOrder: SORT_ORDER;
    isHidden: boolean;
    width: number;
    def: ISuperTableColumn;
    hasSort: boolean;
    hasFilter: boolean;
}
export interface ISuperTableFilter {
    type: FILTER_TYPE;
    title: string;
    isActive: (filterValue: any) => boolean;
    fn: (filterValue: any, value: any, row: Object) => boolean;
    placeholder: string;
    choices?: any[];
}
export interface ISuperTableColumn {
    id: string;
    key: string;
    label: string;
    width?: number;
    lockWidth?: boolean;
    sort?: ISuperTableSorter;
    filter?: ISuperTableFilter;
    format?: ISuperTableCellFormatter;
    component?: any;
    filterChoices?: any[];
}
