import { AfterContentInit, ElementRef, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { ISuperTableColumn, ISuperTableOptions } from './interfaces';
import { SuperTableState } from './SuperTableState';
export declare class SuperTable implements AfterContentInit, OnChanges, OnDestroy, OnInit {
    private el;
    private state;
    rows: Array<any>;
    columns: Array<ISuperTableColumn>;
    options: ISuperTableOptions;
    tableClasses: any;
    isReady: boolean;
    hasError: boolean;
    bodyHeight: number;
    filteredSortedRows: Array<any>;
    private subscription;
    constructor(el: ElementRef, state: SuperTableState);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    private setTableHeight(totalHeight);
    private sortAndFilterRows();
}
