var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input } from '@angular/core';
import { debounce } from 'lodash';
import { SuperTableState } from './SuperTableState';
var TextFilter = (function () {
    function TextFilter(state) {
        this.state = state;
        this.onModelChange = debounce(function () {
            this.state.notify();
        }, 200);
    }
    TextFilter.prototype.clearFilter = function () {
        this.column.filterValue = '';
        this.state.notify();
    };
    return TextFilter;
}());
__decorate([
    Input(),
    __metadata("design:type", Object)
], TextFilter.prototype, "filter", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], TextFilter.prototype, "column", void 0);
TextFilter = __decorate([
    Component({
        selector: '[text-filter]',
        template: "\n    <input\n      class=\"form-control input-sm\"\n      type=\"text\"\n      [(ngModel)]=\"column.filterValue\"\n      (ngModelChange)=\"onModelChange($event)\"\n      [attr.placeholder]=\"filter.placeholder\"\n      [attr.title]=\"filter.title\"\n      [ngClass]=\"{ hasContent: !!column.filterValue }\" />\n\n    <button *ngIf=\"column.filterValue\" class=\"clear-btn\" role=\"button\" (click)=\"clearFilter($event)\">&times;</button>\n  ",
        styles: ["\n    :host {\n      position: relative;\n    }\n    input {\n      width: 100%;\n      font-size: 90%;\n      border: none;\n      border-radius: 0;\n    }\n    .hasContent {\n      background: #dff7ff;\n    }\n    .clear-btn {\n      position: absolute;\n      background: transparent;\n      color: black;\n      right: 0;\n      top: 0;\n      border: none;\n      font-size: 120%;\n    }\n  "]
    }),
    __metadata("design:paramtypes", [SuperTableState])
], TextFilter);
export { TextFilter };
